Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_transition.cpp	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_transition.cpp	(revision 81)
@@ -24,5 +24,5 @@
     log_printf(FUNC,Return_Address_Stack,FUNCTION,"Begin");
 
-    if (PORT_READ(in_NRESET))
+    if (PORT_READ(in_NRESET)==0)
       {
 	for (uint32_t i=0; i<_param->_nb_context; i++)
@@ -30,10 +30,16 @@
 	    reg_TOP    [i] = 0;
 	    reg_BOTTOM [i] = 0;
+	    reg_NB_ELT [i] = 0;
 
 	    reg_PREDICT_TOP    [i] = 0;
 	    reg_PREDICT_BOTTOM [i] = 0;
+	    reg_PREDICT_NB_ELT [i] = 0;
 
 	    for (uint32_t j=0; j<_param->_size_queue [i]; j++)
-	      reg_stack[i][j]._val = false;
+	      {
+		reg_stack[i][j]._val     = false;
+		reg_stack[i][j]._predict = false;
+		reg_stack[i][j]._miss    = false;
+	      }
 	  }
       }
@@ -46,29 +52,45 @@
 	  if (PORT_READ(in_PREDICT_VAL [i]) and internal_PREDICT_ACK [i])
 	    {
-	      Tcontrol_t context = (_param->_have_port_context_id)?PORT_READ(in_PREDICT_CONTEXT_ID [i]):0;
-	      Tcontrol_t push    = PORT_READ(in_PREDICT_PUSH [i]);
-	      Tptr_t     top_old = reg_PREDICT_TOP [i];
-	      Tptr_t     top_new;
-
+	      log_printf(TRACE,Return_Address_Stack,FUNCTION,"PREDICT[%d] : Transaction",i);
+	      Tcontext_t context    = (_param->_have_port_context_id)?PORT_READ(in_PREDICT_CONTEXT_ID [i]):0;
+	      Tcontrol_t push       = PORT_READ(in_PREDICT_PUSH [i]);
+	      Tptr_t     top_old    = reg_PREDICT_TOP    [context];
+	      Tptr_t     top_new    = top_old;
+	      Tptr_t     bottom_old = reg_PREDICT_BOTTOM [context];
+
+	      log_printf(TRACE,Return_Address_Stack,FUNCTION," * context : %d",context);
+
+	      // Hit  : push or (val and not miss and not empty)
+	      // Miss : ifetch is stall, no update
 	      if (internal_PREDICT_HIT [i])
 		{
+		  log_printf(TRACE,Return_Address_Stack,FUNCTION," * before");
+		  log_printf(TRACE,Return_Address_Stack,FUNCTION,"   * reg_predict_top     : %d",reg_PREDICT_TOP    [context]);
+		  log_printf(TRACE,Return_Address_Stack,FUNCTION,"   * reg_predict_bottom  : %d",reg_PREDICT_BOTTOM [context]);
+		  log_printf(TRACE,Return_Address_Stack,FUNCTION,"   * reg_predict_nb_elt  : %d",reg_PREDICT_NB_ELT [context]);
+
 		  if (push)
 		    {
-		      // push
+		      // push : increase the top (circular)
 		      top_new = (top_old+1)%_param->_size_queue[context];
 		      
 		      reg_stack [context][top_new]._val     = true; // New addr
-		      reg_stack [context][top_new]._predict = true; // Is speculative (erase a old addr)
+		      reg_stack [context][top_new]._predict = true; // Is speculative (erase a old addr (or not))
 		    //reg_stack [context][top_new]._miss    = ;
 		      reg_stack [context][top_new]._address = PORT_READ(in_PREDICT_ADDRESS_PUSH [i]);
 
 		      // the stack is full, erase the most old stack
-		      if (top_new == reg_PREDICT_BOTTOM [i])
-			reg_PREDICT_BOTTOM [i] = (reg_PREDICT_BOTTOM [i]+1)%_param->_size_queue[context];
+
+		      // Test if full
+		      if (reg_PREDICT_NB_ELT[context]==_param->_size_queue[context])
+			reg_PREDICT_BOTTOM [context] = (bottom_old+1)%_param->_size_queue[context];
+		      // A new data is write : the stack is not empty
+		      if (reg_PREDICT_NB_ELT[context]< _param->_size_queue[context])
+			reg_PREDICT_NB_ELT[context]++;
 		    }
 		  else
 		    {
 		      // pop
-		      top_new = (top_old==0)?(_param->_size_queue[context]-1):(top_old-1);
+// 		      top_new = (top_old==0)?(_param->_size_queue[context]-1):(top_old-1);
 		      
 		    //reg_stack [context][top_new]._val     = ;
@@ -78,71 +100,104 @@
 
 		      // the stack is empty
-		      if (top_old == reg_PREDICT_BOTTOM [i])
-			reg_PREDICT_BOTTOM [i] = top_new;
-
+		      if (reg_PREDICT_NB_ELT[context]>0)
+			{
+			  top_new = (top_old==0)?(_param->_size_queue[context]-1):(top_old-1);
+			  reg_PREDICT_NB_ELT[context] --;
+			}
 		    }
 		  
-		  reg_PREDICT_TOP [i] = top_new;
+		  reg_PREDICT_TOP [context] = top_new;
+
+		  log_printf(TRACE,Return_Address_Stack,FUNCTION," * after");
+		  log_printf(TRACE,Return_Address_Stack,FUNCTION,"   * reg_predict_top     : %d",reg_PREDICT_TOP    [context]);
+		  log_printf(TRACE,Return_Address_Stack,FUNCTION,"   * reg_predict_bottom  : %d",reg_PREDICT_BOTTOM [context]);
+		  log_printf(TRACE,Return_Address_Stack,FUNCTION,"   * reg_predict_nb_elt  : %d",reg_PREDICT_NB_ELT [context]);
 		}
 	    }
 
-// 	// ===================================================================
-// 	// =====[ DECOD ]=====================================================
-// 	// ===================================================================
-// 	for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
-// 	  if (PORT_READ(in_DECOD_VAL [i]) and internal_DECOD_ACK [i])
-// 	    {
-// 	      Tcontrol_t context = (_param->_have_port_context_id)?PORT_READ(in_DECOD_CONTEXT_ID [i]):0;
-// 	      Tcontrol_t push    = PORT_READ(in_DECOD_PUSH [i]);
-// 	      Tptr_t     top_old = reg_TOP [i];
-// 	      Tptr_t     top_new;
-
-// 	      Tcontrol_t hit  = PORT_READ(in_DECOD_HIT             [i]);
-// 	      Tcontrol_t miss = PORT_READ(in_DECOD_MISS_PREDICTION [i]);
-
-// 	      if (push)
-// 		{
-// 		  // push
-// 		  top_new = (top_old+1)%_param->_size_queue[context];
-
-// 		  reg_stack [context][top_new]._val     = true;
-// 		  reg_stack [context][top_new]._predict = false;
-// 		  reg_stack [context][top_new]._miss    = false;
-// 		  reg_stack [context][top_new]._address = PORT_READ(in_DECOD_ADDRESS_PUSH [i]);
-
-// 		  // the stack is full, erase the most old stack
-// 		  if (top_old == reg_BOTTOM [i])
-// 		    reg_BOTTOM [i] = top_new;
-// 		}
-// 	      else
-// 		{
-// 		  // pop
+	// ===================================================================
+	// =====[ DECOD ]=====================================================
+	// ===================================================================
+	for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+	  if (PORT_READ(in_DECOD_VAL [i]) and internal_DECOD_ACK [i])
+	    {
+	      log_printf(TRACE,Return_Address_Stack,FUNCTION,"DECOD[%d] : Transaction",i);
+	      Tcontext_t context    = (_param->_have_port_context_id)?PORT_READ(in_DECOD_CONTEXT_ID [i]):0;
+	      Tcontrol_t push       = PORT_READ(in_DECOD_PUSH [i]);
+	      Tptr_t     top_old    = reg_TOP    [context];
+	      Tptr_t     top_new    = top_old;
+	      Tptr_t     bottom_old = reg_BOTTOM [context];
+	      //Tcontrol_t hit        = internal_DECOD_HIT [i];
+	      Tcontrol_t miss       = PORT_READ(in_DECOD_MISS_PREDICTION [i]);
+
+	      log_printf(TRACE,Return_Address_Stack,FUNCTION," * context : %d",context);
+
+	      log_printf(TRACE,Return_Address_Stack,FUNCTION," * before");
+	      log_printf(TRACE,Return_Address_Stack,FUNCTION,"   * reg_top     : %d",reg_TOP    [context]);
+	      log_printf(TRACE,Return_Address_Stack,FUNCTION,"   * reg_bottom  : %d",reg_BOTTOM [context]);
+	      log_printf(TRACE,Return_Address_Stack,FUNCTION,"   * reg_nb_elt  : %d",reg_NB_ELT [context]);
+
+	      if (push)
+		{
+		  // push : increase the top (circular)
+		  top_new = (top_old+1)%_param->_size_queue[context];
+		  
+		  reg_stack [context][top_new]._val     = true;  // New address
+		  reg_stack [context][top_new]._predict = false; // No speculative
+		  reg_stack [context][top_new]._miss    = false;
+		  reg_stack [context][top_new]._address = PORT_READ(in_DECOD_ADDRESS_PUSH [i]);
+		  
+		  // Test if full : if true, then icrease the bottom (erase the most old stack)
+		  if (reg_NB_ELT[context]==_param->_size_queue[context])
+		    reg_BOTTOM [context] = (bottom_old+1)%_param->_size_queue[context];
+		  // A new data is write : the stack is not empty
+		  if (reg_NB_ELT[context]< _param->_size_queue[context])
+		    reg_NB_ELT[context]++;
+		}
+	      else
+		{
+		  // pop
 // 		  top_new = (top_old==0)?(_param->_size_queue[context]-1):(top_old-1);
 
-// 		//reg_stack [context][top_new]._val     = ;
-// 		//reg_stack [context][top_new]._predict = ;
-// 		//reg_stack [context][top_new]._miss    = ;
-// 		//reg_stack [context][top_new]._address = ; 
-// 		}
-
-// 	      reg_TOP [i] = top_new;
-
-// 	      // have previous miss of ifetch ?
-// 	      // 2 miss : 
-// 	      //   1) miss predict : is very limited (local at context), can be update very quickly
-// 	      //   2) miss decod   : result is in commit stage ... 
-// 	      if (miss)
-// 		{
-// 		  reg_PREDICT_BOTTOM [i] = reg_BOTTOM [i];
-// 		  reg_PREDICT_TOP    [i] = reg_TOP    [i];
-
-// 		  for (uint32_t j=0; j<_param->_size_queue [i]; j++)
-// 		    if (reg_stack [context][top_new]._predict)
-// 		      {
-// 			reg_stack [context][top_new]._predict = false;
-// 			reg_stack [context][top_new]._miss    = true;
-// 		      }
-// 		}
-// 	    }
+		  //reg_stack [context][top_new]._val     = ;
+		  //reg_stack [context][top_new]._predict = ;
+		  //reg_stack [context][top_new]._miss    = ;
+		  //reg_stack [context][top_new]._address = ; 
+		  
+		  // the stack is empty
+		  if (reg_NB_ELT[context]>0)
+		    {
+		      top_new = (top_old==0)?(_param->_size_queue[context]-1):(top_old-1);
+		      reg_NB_ELT[context] --;
+		    }
+		}
+	      
+	      reg_TOP [context] = top_new;
+	      
+	      log_printf(TRACE,Return_Address_Stack,FUNCTION," * after");
+	      log_printf(TRACE,Return_Address_Stack,FUNCTION,"   * reg_top     : %d",reg_TOP    [context]);
+	      log_printf(TRACE,Return_Address_Stack,FUNCTION,"   * reg_bottom  : %d",reg_BOTTOM [context]);
+	      log_printf(TRACE,Return_Address_Stack,FUNCTION,"   * reg_nb_elt  : %d",reg_NB_ELT [context]);
+
+	      // have previous miss of ifetch ?
+	      // 2 miss : 
+	      //   1) miss predict : is very limited (local at context), can be update very quickly
+	      //   2) miss decod   : result is in commit stage ... 
+	      if (miss)
+		{
+		  reg_PREDICT_BOTTOM [context] = reg_BOTTOM [context];
+		  reg_PREDICT_TOP    [context] = reg_TOP    [context];
+		  reg_PREDICT_NB_ELT [context] = reg_NB_ELT [context];
+		  
+		  // Scan full assoc !!!
+		  for (uint32_t j=0; j<_param->_size_queue [i]; j++)
+		    // Test if this slot is tagged with "predict" : if true, tagged as miss
+		    if (reg_stack [context][j]._predict)
+		      {
+			reg_stack [context][j]._predict = false;
+			reg_stack [context][j]._miss    = true;
+		      }
+		}
+	    }
 
 	// ===================================================================
@@ -152,32 +207,39 @@
 	  if (PORT_READ(in_UPDATE_VAL [i]) and internal_UPDATE_ACK [i])
 	    {
-	      Tcontrol_t context = (_param->_have_port_context_id)?PORT_READ(in_UPDATE_CONTEXT_ID [i]):0;
-	      Tcontrol_t push    = PORT_READ(in_UPDATE_PUSH  [i]);
-	      Tptr_t     index   = PORT_READ(in_UPDATE_INDEX [i]);
+	      ERRORMORPHEO(FUNCTION,"Fonction à implémenter !!!!!!!!!!!!");
 	      
-	      if (PORT_READ(in_UPDATE_MISS_PREDICTION [i]))
-		{
-		  if (push)
-		    {
-		      // push
-		      top_new = (top_old+1)%_param->_size_queue[context];
+
+// 	      Tcontrol_t miss   = PORT_READ(in_UPDATE_MISS_PREDICTION [i]);
+// 	      // 
+// 	      if (miss)
+// 		{
+// 		  Tcontrol_t context = (_param->_have_port_context_id)?PORT_READ(in_UPDATE_CONTEXT_ID [i]):0;
+// 		  Tcontrol_t ifetch  = PORT_READ(in_UPDATE_PREDICTION_IFETCH [i]);
+// 		  Tcontrol_t push    = PORT_READ(in_UPDATE_PUSH             [i]);
+// 		  Tptr_t     index   = PORT_READ(in_UPDATE_INDEX            [i]);
+// 		  Taddress_t address = PORT_READ(in_UPDATE_ADDRESS          [i]);
+		  
+// 		  if (push)
+// 		    {
+// // 		      // push
+// // 		      top_new = (top_old+1)%_param->_size_queue[context];
 		      
-		      reg_stack [context][index]._val     = true;
-		      reg_stack [context][index]._predict = false;
-		      reg_stack [context][index]._miss    = false;
-		      reg_stack [context][index]._address = PORT_READ(in_UPDATE_ADDRESS [i]);
-
-		    }
-		  else
-		    {
-		    //reg_stack [context][top_new]._val     = ;
-		    //reg_stack [context][top_new]._predict = ;
-		    //reg_stack [context][top_new]._miss    = ;
-		    //reg_stack [context][top_new]._address = ; 
-		    }
-		  
-		  // Mouais bof .......
-		  reg_PREDICT_TOP [i] = index;
-		}
+// // 		      reg_stack [context][index]._val     = true;
+// // 		      reg_stack [context][index]._predict = false;
+// // 		      reg_stack [context][index]._miss    = false;
+// // 		      reg_stack [context][index]._address = PORT_READ(in_UPDATE_ADDRESS [i]);
+
+// 		    }
+// 		  else
+// 		    {
+// // 		    //reg_stack [context][top_new]._val     = ;
+// // 		    //reg_stack [context][top_new]._predict = ;
+// // 		    //reg_stack [context][top_new]._miss    = ;
+// // 		    //reg_stack [context][top_new]._address = ; 
+// 		    }
+		  
+// // // 		  // Mouais bof .......
+// // // 		  reg_PREDICT_TOP [context] = index;
+// 		}
 	    }
       }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/test.cpp	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/test.cpp	(revision 81)
@@ -7,38 +7,10 @@
  */
 
+#define NB_ITERATION  1
+#define CYCLE_MAX     (128*NB_ITERATION)
+
 #include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/include/test.h"
 #include "Common/include/Test.h"
 #include "Behavioural/include/Allocation.h"
-
-#define NB_ITERATION  1
-#define CYCLE_MAX     (128*NB_ITERATION)
-
-#define LABEL(str...)							\
-  {									\
-    msg (_("{%d} "),static_cast<uint32_t>(sc_simulation_time()));	\
-    msg (str);								\
-    msg (_("\n"));							\
-  } while(0)
-
-#define SC_START(cycle_offset)                                                       \
-  do									             \
-    {									             \
-      /*cout << "SC_START (begin)" << endl;*/				             \
-									             \
-      uint32_t cycle_current = static_cast<uint32_t>(sc_simulation_time());          \
-      if (cycle_offset != 0)						             \
-	{								             \
-	  cout << "##########[ cycle "<< cycle_current+cycle_offset << " ]" << endl; \
-	}								             \
-									             \
-      if (cycle_current > CYCLE_MAX)					             \
-	{								             \
-	  TEST_KO("Maximal cycles Reached");				             \
-	}								             \
-									             \
-      sc_start(cycle_offset);						             \
-									             \
-      /*cout << "SC_START (end  )" << endl;*/				             \
-    } while(0)
 
 void test (string name,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/config_mono_context.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/config_mono_context.cfg	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/config_mono_context.cfg	(revision 81)
@@ -0,0 +1,10 @@
+Update_Prediction_Table
+1	1	+1	# nb_context             
+1	4	*4	# size_queue             [0] [nb_context]
+32	32	*2	# size_address           
+4	4	*4	# nb_inst_predict        
+4	4	*4	# nb_inst_decod          
+4	4	*4	# nb_inst_branch_complete
+4	4	*4	# nb_inst_update         
+0	0	+1	# size_history           
+3	3	*2	# size_ras_index         [0] [nb_context]
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/config_multi_context.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/config_multi_context.cfg	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/config_multi_context.cfg	(revision 81)
@@ -0,0 +1,16 @@
+Update_Prediction_Table
+4	4	+1	# nb_context             
+4	4	*4	# size_queue             [0] [nb_context]
+1	1	*4	# size_queue             [1] [nb_context]
+8	8	*4	# size_queue             [2] [nb_context]
+2	2	*4	# size_queue             [3] [nb_context]
+32	32	*2	# size_address           
+4	4	*4	# nb_inst_predict        
+4	4	*4	# nb_inst_decod          
+4	4	*4	# nb_inst_branch_complete
+4	4	*4	# nb_inst_update         
+0	0	+1	# size_history           
+3	3	*2	# size_ras_index         [0] [nb_context]
+1	1	*2	# size_ras_index         [1] [nb_context]
+2	2	*2	# size_ras_index         [2] [nb_context]
+8	8	*2	# size_ras_index         [3] [nb_context]
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/main.cpp	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/main.cpp	(revision 81)
@@ -8,5 +8,5 @@
 #include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/include/test.h"
 
-#define NB_PARAMS 0
+#define NB_PARAMS 7
 
 void usage (int argc, char * argv[])
@@ -14,5 +14,13 @@
   err (_("<Usage> %s name_instance list_params.\n"),argv[0]);
   err (_("list_params is :\n"));
-  err (_(" * ()\n"));
+  err (_(" * nb_context                           (uint32_t)\n"));
+  err (_(" * size_queue              [nb_context] (uint32_t)\n"));
+  err (_(" * size_address                         (uint32_t)\n"));
+  err (_(" * nb_inst_predict                      (uint32_t)\n"));
+  err (_(" * nb_inst_decod                        (uint32_t)\n"));
+  err (_(" * nb_inst_branch_complete              (uint32_t)\n"));
+  err (_(" * nb_inst_update                       (uint32_t)\n"));
+  err (_(" * size_history                         (uint32_t)\n"));
+  err (_(" * size_ras_index          [nb_context] (uint32_t)\n"));
 
   exit (1);
@@ -25,5 +33,5 @@
 #endif
 {
-  if (argc != static_cast<int>(2+NB_PARAMS))
+  if (argc <= static_cast<int>(2+NB_PARAMS))
     usage (argc, argv);
 
@@ -31,6 +39,22 @@
 
   string name = argv[x++];
-//const uint32_t size_data = atoi(argv[x++]);
-//const uint32_t nb_port   = atoi(argv[x++]);
+
+  uint32_t   _nb_context              = fromString<uint32_t>(argv[x++]);
+
+  if (argc != static_cast<int>(2+NB_PARAMS+2*_nb_context))
+    usage (argc, argv);
+
+  uint32_t * _size_queue              = new uint32_t [_nb_context];
+  for (uint32_t i=0; i<_nb_context; i++)
+    _size_queue [i] = fromString<uint32_t>(argv[x++]);
+  uint32_t   _size_address            = fromString<uint32_t>(argv[x++]);
+  uint32_t   _nb_inst_predict         = fromString<uint32_t>(argv[x++]);
+  uint32_t   _nb_inst_decod           = fromString<uint32_t>(argv[x++]);
+  uint32_t   _nb_inst_branch_complete = fromString<uint32_t>(argv[x++]);
+  uint32_t   _nb_inst_update          = fromString<uint32_t>(argv[x++]);
+  uint32_t   _size_history            = fromString<uint32_t>(argv[x++]);
+  uint32_t * _size_ras_index          = new uint32_t [_nb_context];
+  for (uint32_t i=0; i<_nb_context; i++)
+    _size_ras_index [i] = fromString<uint32_t>(argv[x++]);
 
   int _return = EXIT_SUCCESS;
@@ -38,7 +62,13 @@
     {
       morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::Parameters * param = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::Parameters
-	(//size_data,
-	 //nb_port  
-        );
+	(_nb_context             ,
+	 _size_queue             ,
+	 _size_address           ,
+	 _nb_inst_predict        ,
+	 _nb_inst_decod          ,
+	 _nb_inst_branch_complete,
+	 _nb_inst_update         ,
+	 _size_history           ,
+	 _size_ras_index         );
       
       msg(_("%s"),param->print(1).c_str());
@@ -57,4 +87,8 @@
     }
 
+
+  delete [] _size_ras_index;
+  delete [] _size_queue;
+
   return (_return);
 }
